package io.dekorate.prometheus.config;

import io.dekorate.project.Project;
import io.dekorate.kubernetes.config.ConfigKey;
import io.dekorate.kubernetes.config.Configuration;
import java.lang.Object;
import java.lang.String;
import java.util.Map;
import io.sundr.builder.annotations.Buildable;

@Buildable(builderPackage = "io.dekorate.deps.kubernetes.api.builder") public class ServiceMonitorConfig extends Configuration{

    private String port = "http";
    private String path = "/metrics";
    private int interval = 10;
    private boolean honorLabels = false;

    public ServiceMonitorConfig(){
    }
    public ServiceMonitorConfig(Project project,Map<ConfigKey,Object> attributes,String port,String path,int interval,boolean honorLabels){
            super(project, attributes);
            this.port = port != null ? port : "http";
            this.path = path != null ? path : "/metrics";
            this.interval = interval;
            this.honorLabels = honorLabels;
    }

    public String getPort(){
            return this.port;
    }

    public String getPath(){
            return this.path;
    }

    public int getInterval(){
            return this.interval;
    }

    public boolean isHonorLabels(){
            return this.honorLabels;
    }

    public static ServiceMonitorConfigBuilder newServiceMonitorConfigBuilder(){
            return new io.dekorate.prometheus.config.ServiceMonitorConfigBuilder();
    }




}
